package dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.time.LocalDate;
import java.time.LocalTime;
import java.util.ArrayList;
import java.util.List;

public class MessageJdbcDao implements MessageDao{
    UtilisateurJdbcDao jdbcUser = new UtilisateurJdbcDao();

    //find a message by its id
    @Override
    public Message findById(int idMessage) {
        try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT * FROM Message WHERE idMessage = "+ idMessage +";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            rs.next();
            Message message = new Message(rs.getInt(1), rs.getInt(2), rs.getDate(3).toLocalDate(), rs.getTime(4).toLocalTime(), rs.getString(5), jdbcUser.findByEmail(rs.getString(6)));
            rs.close();
            con.close();
            return message;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new Message(0, 0, LocalDate.now(), LocalTime.now(), "err", new Utilisateur("err", "err", "err"));
    }

    //find all message from one user
    @Override
    public List<Message> findAll(Utilisateur utilisateur) {
        try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT * FROM Message WHERE email = '"+utilisateur.getEmail()+"';";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            List<Message> list = new ArrayList<Message>();
            while(rs.next()){
                list.add(new Message(rs.getInt(1), rs.getInt(2), rs.getDate(3).toLocalDate(), rs.getTime(4).toLocalTime(), rs.getString(5), jdbcUser.findByEmail(rs.getString(6))));
            }
            rs.close();
            con.close();
            return list;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new ArrayList<Message>();
    }

    //find all the messages from a cnversation
    @Override
    public List<Message> findAll(Conversation conversation) {
        try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "SELECT * FROM Message WHERE idConv = "+conversation.getIdConv()+";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            List<Message> list = new ArrayList<Message>();
            while(rs.next()){
                list.add(new Message(rs.getInt(1), rs.getInt(2), rs.getDate(3).toLocalDate(), rs.getTime(4).toLocalTime(), rs.getString(5), jdbcUser.findByEmail(rs.getString(6))));
            }
            rs.close();
            con.close();
            return list;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return new ArrayList<Message>();
    }

    //create a new message in a conv
    @Override
    public boolean createMessage(Utilisateur utilisateur, String message, int idConv) {
        try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "INSERT INTO Messages(message, utilisateur, idConv) VALUES('"+message+"', '"+utilisateur.getEmail()+"','"+idConv+"');";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            rs.next();
            rs.close();
            con.close();
            return true;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return false;
    }

    //update a message
    @Override
    public boolean updateMessage(int idMessage, String message) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'updateMessage'");
    }

    @Override
    public boolean deleteMessage(int idMessage) {
        try (Connection con = getCon(); Statement stmt = con.createStatement()) {
            String sql = "DELETE FROM Messages CASCADE WHERE idMessage = "+idMessage+";";
            System.err.println(sql);
            ResultSet rs = stmt.executeQuery(sql);
            rs.next();
            rs.close();
            con.close();
            return true;
        }catch (SQLException e) {
            System.out.println("Erreur lors de l'accès à la base de données : " + e.getMessage());
            e.printStackTrace();
        }
        return false;
    }
    
    private Connection getCon() {
        
        try {

            String driver = "org.postgresql.Driver";
            String url = "jdbc:postgresql://psqlserv/but2";
            String nom = "alexandredehaineetu";
            String mdp = "moi";

            Class.forName(driver);
            return DriverManager.getConnection(url, nom, mdp);

        } catch (Exception e) {
            System.out.println(e.getMessage());
        }

        return null;

    }
}
